function Start()
{
	this.transform.position = new Vector3(1,0,1);
}

/*action codes
0 - forward 1
1 - turn left move 1
2 - turn right move 1
3 - turn around move 1
*/
function JumpForward()
{
	this.animation.Play("jump");
}


function Update () 
{
	//if jump animation is playing wait for it to finish before
	//determining next move
	if(this.animation.isPlaying) 
	{
		this.transform.Translate(Vector3(0,0, Time.deltaTime * 1.0/this.animation["jump"].length));
		return;
	}
	
	//round off the position to the nearest whole number so
	//bot remains in position on the grid
	this.transform.position = new Vector3( Mathf.Round(this.transform.position.x),
											0,
											Mathf.Round(this.transform.position.z));
	
	var x: int = this.transform.position.x;
	var z: int = this.transform.position.z;	
	this.GetComponent("details").visited(x,z);
	
	//create binary code of situation-----
	var binaryCode: int[] = new int[6];
	//are there any walls 
	var fwd = transform.TransformDirection (Vector3.forward);
	var right = transform.TransformDirection (Vector3.right);
	
	if (Physics.Raycast (transform.position, -right, 1)) 
	{
		//print ("There is something to the left of the object!");
		binaryCode[0] = 1;
		binaryCode[1] = this.GetComponent("details").wasVisited(this.transform.position - right);
	}
	
	if (Physics.Raycast (transform.position, fwd, 1)) 
	{
		//print ("There is something in front of the object!");
		binaryCode[2] = 1;
		binaryCode[3] = this.GetComponent("details").wasVisited(this.transform.position + fwd);
	}

	if (Physics.Raycast (transform.position, right, 1)) 
	{
		//print ("There is something to the right of the object!");
		binaryCode[4] = 1;
		binaryCode[5] = this.GetComponent("details").wasVisited(this.transform.position + right);
	}
	
   	//convert binary code into a decimal value ----
   	var i = 0; 
   	var decimal = 0;
   	while ( i < binaryCode.length)
   	{
      	decimal = decimal * 2 + (binaryCode[i++]);
   	}
   	//----------------------------------------------
   	
	//JumpForward();
	
	if(this.GetComponent("details").dna[decimal] == 0)  //forward 1
	{
		JumpForward();
	}
	else if(this.GetComponent("details").dna[decimal] == 1) //turn left move 1
	{
		this.transform.Rotate(-Vector3.up * 90);
		JumpForward();
	}
	else if(this.GetComponent("details").dna[decimal] == 2) //turn right move 1
	{
		this.transform.Rotate(Vector3.up * 90);
		JumpForward();
	}
	else if(this.GetComponent("details").dna[decimal] == 3) //turn around move 1
	{
		this.transform.Rotate(Vector3.up * 180);
		JumpForward();
	}
	
	
	
}