var bot: GameObject;
private var cycleStartTime = 0;
private var cycleTime = 60;

private var bots = new Array();
private var numOfBots = 100;
var startingPos: Transform;

private var generation = 1;
private var averageScore:float;

function OnGUI()
{
	GUI.BeginGroup (Rect (10, 10, 150, 150));
	GUI.Box (Rect (0,0,140,140), "Stats");
	GUI.Label(Rect (10,20,100,30), "Gen: " + generation);
	var timeElapsed = Time.fixedTime - cycleStartTime;
	GUI.Label(Rect (10,40,100,30), "Time: " + timeElapsed);
	GUI.Label(Rect (10,60,100,30), "Avg Score: " + averageScore);
	GUI.EndGroup ();
}

class BotResult implements System.IComparable
{
    var go: GameObject;
    var collisionCount : int;
    var visitedCount : int;
    var score: int;

    function BotResult(g: GameObject, c : float, v: float)
    {
        go = g;
        collisionCount = c;
        visitedCount = v;
        score = v;
    }

    function CompareTo(other : System.Object) : int
    {
         return score.CompareTo(other.score);
    }
}


function Start()
{
	//create a bunch of bots at the starting position
	for(var i=0; i < numOfBots; i++)
	{
		Instantiate(bot, startingPos.position, Quaternion.identity);	
	}
	cycleStartTime = Time.fixedTime;
	GameObject.Find("Main Camera").GetComponent("TextEditor").WriteToFile("----Start Data----" +  "\n");	
}

function CalcAverage()
{
	var gos : GameObject[];
	gos = GameObject.FindGameObjectsWithTag("goob");
	var avg:float = 0;
	GameObject.Find("Main Camera").GetComponent("TextEditor").WriteToFile("----Generation----" + generation + "\n");
	for (var go : GameObject in gos) 
	{
		avg += go.GetComponent("details").countVisited();
		GameObject.Find("Main Camera").GetComponent("TextEditor").WriteToFile(go.GetComponent("details").countVisited() +  "\n");
	} 
	avg /= gos.length;
	averageScore = avg;
}


function breed()
{
	var gos : GameObject[];
	gos = GameObject.FindGameObjectsWithTag("goob");
	bots = new Array();
	var avg:float = 0;
	for (var go : GameObject in gos) 
	{
		bots.Push(new BotResult(go, go.GetComponent("details").collisionCount, go.GetComponent("details").countVisited()));
		avg += go.GetComponent("details").countVisited();
	} 
	
	bots.sort();
	bots.reverse();
	

	var numBots: float = gos.length;
	GameObject.Find("Main Camera").GetComponent("TextEditor").WriteToFile("Best Score --------- " + bots[0].score + "\n");
	GameObject.Find("Main Camera").GetComponent("TextEditor").WriteToFile("Average = " + avg/bots.length + "\n");
	GameObject.Find("Main Camera").GetComponent("TextEditor").WriteToFile("Worst = " + bots[bots.length-1].score + "\n");

	//breed each second bot together and cross the dna
	for (i = 0; i < numOfBots/4.0; i++) 
	{
		var b1 = Instantiate(bot, startingPos.position, Quaternion.identity);
		var b2 = Instantiate(bot, startingPos.position, Quaternion.identity);
		var b3 = Instantiate(bot, startingPos.position, Quaternion.identity);
		var b4 = Instantiate(bot, startingPos.position, Quaternion.identity);
		var spliceAt = Random.Range(1,bots[i].go.GetComponent("details").dna.length);
		for(j = 0; j <  bots[i].go.GetComponent("details").dna.length; j++)
		{
			if(j < spliceAt)
			{
				b1.GetComponent("details").dna[j] = bots[i].go.GetComponent("details").dna[j];
				b2.GetComponent("details").dna[j] = bots[i].go.GetComponent("details").dna[j];	
				b3.GetComponent("details").dna[j] = bots[i+1].go.GetComponent("details").dna[j];	
				b4.GetComponent("details").dna[j] = bots[i+1].go.GetComponent("details").dna[j];		
			}
			else
			{
				b1.GetComponent("details").dna[j] = bots[i+1].go.GetComponent("details").dna[j];
				b2.GetComponent("details").dna[j] = bots[i+1].go.GetComponent("details").dna[j];
				b3.GetComponent("details").dna[j] = bots[i].go.GetComponent("details").dna[j];
				b4.GetComponent("details").dna[j] = bots[i].go.GetComponent("details").dna[j];
			}
			
			if(Random.Range(0,100) == 1) //mutate
			{
				b1.GetComponent("details").dna[j] = Random.Range(0,4);
				b2.GetComponent("details").dna[j] = Random.Range(0,4);	
				b3.GetComponent("details").dna[j] = Random.Range(0,4);	
				b4.GetComponent("details").dna[j] = Random.Range(0,4);
			}
		}	
	}
	
	//Destroy all original bots
	for (i = 0; i < bots.length; i++) 
	{
			Destroy(bots[i].go.gameObject);
	}
	generation++;
}

function Update () 
{
	if(Time.fixedTime > cycleTime + cycleStartTime)
	{
		breed();
		cycleStartTime = Time.fixedTime;

	}
	if(Random.Range(0,3) == 1)  CalcAverage();
}

