var block: GameObject;	//object for building walls

private var width = 40;
private var depth = 40;
private var gridSize:int = width * depth;

//internal array for storing wall locations
private var gridmap = new Array(width*depth);


function getSize()
{
	return gridSize;	
}

function getWidth()
{
	return width;	
}

function Awake()
{
	//create boundary walls
	for(var w = 0; w < width; w++)
	{
		for(var d = 0; d < depth; d++)
		{
			if( w == 0 || d == 0)	//outside walls bottom and left
			{
				gridmap[w + d * width] = Instantiate(block, Vector3(w,0,d), Quaternion.identity);
			}			
			else if(w == width-1 || d == depth-1) //outside walls top and right
			{
				gridmap[w + d * width] = Instantiate(block, Vector3(w,0,d), Quaternion.identity);
			}
			else if(Random.Range(0,5) < 1)
			{
				gridmap[w + d * width] = Instantiate(block, Vector3(w,0,d), Quaternion.identity);
			}
		}	
	}
	
	//destroy wall if in the starting position
	if(gridmap[1 + 1 * width])
		Destroy(gridmap[1 + 1 * width].gameObject);
		
}

function wallCount()
{
	var walls = 0;
	for(var i = 0; i < (width*depth); i++)
	{
		if(gridmap[i])	
			walls++;
	}	
	return walls;
}

function Update () {
}